import { FulfillableGoalDetails, FulfillableGoalWithRegistrations, Goal, ImplementationRegistration } from "@atomist/sdm";
import { DockerImageNameCreator, DockerOptions } from "./executeDockerBuild";
/**
 * Registration for a certain docker build and push configuration
 */
export interface DockerBuildRegistration extends Partial<ImplementationRegistration> {
    /**
     * Options to configure the docker build
     */
    options?: DockerOptions;
    /**
     * @deprecated use options.dockerImageNameCreator
     */
    imageNameCreator?: DockerImageNameCreator;
}
/**
 * Goal that performs docker build and push depending on the provided options
 */
export declare class DockerBuild extends FulfillableGoalWithRegistrations<DockerBuildRegistration> {
    private readonly goalDetailsOrUniqueName;
    constructor(goalDetailsOrUniqueName?: FulfillableGoalDetails | string, ...dependsOn: Goal[]);
    with(registration: DockerBuildRegistration): this;
}
